include Snippo.inc

.data
	AllSnippets dd 0
	set AllSnippets as ObjVector
	
	
	
	SelIndex	dd -1
	SelSnippo	dd 0
	
	
	
	SnippetsDBFileName db "Snippos.bin",0
.code




LoadSnippets proc UseAll
	LOCAL f1,pSnippo
	LOCAL sn1:Snippo
	mov AllSnippets, new(ObjVector)
	mov f1,fopen(addr SnippetsDBFileName,"rb");
	cmp eax,-1
	je _ret
	
	cmp Read4(),'SNIP'
	jne done
	
	
	
	nextSnip:
		mov sn1.lsize,Read4()
		mov sn1.dsize,Read4()
		
		cmp sn1.lsize,0
		je done
		
		mov sn1.pLabel,malloc(sn1.lsize)
		mov sn1.pData ,malloc(sn1.dsize)
		
		
		fread f1,sn1.pLabel,sn1.lsize
		fread f1,sn1.pData ,sn1.dsize
		
		invoke memclone,addr sn1,Snippo
		mov pSnippo,eax
		pcall AllSnippets.insert,eax
		
		invoke SendMessage,hList,LB_ADDSTRING,0,sn1.pLabel
		invoke SendMessage,hList,LB_SETITEMDATA,eax,pSnippo
		
		jmp nextSnip
	done:
	fclose f1	
	
	
_ret:	ret
LoadSnippets endp

SaveSnippets proc UseAll
	LOCAL f1
	mov f1,fopen(addr SnippetsDBFileName,"wb");
	
	Write4 'SNIP'
	
	.ForEach AllSnippets
		Write4 [edx].Snippo.lsize
		Write4 [edx].Snippo.dsize
		fwrite f1,[edx].Snippo.pLabel,[edx].Snippo.lsize
		fwrite f1,[edx].Snippo.pData ,[edx].Snippo.dsize
	.EndForEach AllSnippets
	
	fclose f1
	ret
SaveSnippets endp


start:

	invoke GetModuleHandle,NULL
	mov		hInstance,eax

    invoke InitCommonControls
	invoke DialogBoxParam,hInstance,IDD_DIALOG1,NULL,addr DlgProc,NULL
	invoke SaveSnippets
	invoke ExitProcess,0

;########################################################################

DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL sn1:Snippo
	LOCAL pSnippo
	
	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		mov hList ,$invoke(GetDlgItem,hWin,1001)
		mov hLabel,$invoke(GetDlgItem,hWin,1003)
		mov hCode ,$invoke(GetDlgItem,hWin,1007)
		
		mov hbNewSnipp	 ,$invoke(GetDlgItem,hWin,1002)
		mov hbDeleteSnipp,$invoke(GetDlgItem,hWin,1008)
		mov hbUpdateSnipp,$invoke(GetDlgItem,hWin,1011)
		mov hbOK		 ,$invoke(GetDlgItem,hWin,1010)
		mov hbCancel	 ,$invoke(GetDlgItem,hWin,1009)
		
		invoke LoadSnippets
	.elseif eax==WM_COMMAND
		.if wParam==1002 ; "New Snippet"
			;---------[ new snippet -prepare ]--------------------\
			invoke SetWindowText,hLabel,0
			invoke SetWindowText,hCode,0
			
			invoke EnableWindow,hList,FALSE
			invoke ShowWindow,hbNewSnipp	,SW_HIDE
			invoke ShowWindow,hbDeleteSnipp	,SW_HIDE
			invoke ShowWindow,hbUpdateSnipp	,SW_HIDE
			invoke ShowWindow,hbOK		,SW_SHOW
			invoke ShowWindow,hbCancel	,SW_SHOW
			;-----------------------------------------------------/
		.elseif wParam==1009 ; "Cancel"
			;---------[ new snippet - cancel ]-----------------\
			invoke EnableWindow,hList,TRUE
			invoke ShowWindow,hbNewSnipp,SW_SHOW
			invoke ShowWindow,hbOK		,SW_HIDE
			invoke ShowWindow,hbCancel	,SW_HIDE
			
			jmp OnListBoxSelect 
			;--------------------------------------------------/
		.elseif wParam==1010 ; "OK"
			;---------[ new snippet - OK ]----------------\
			invoke GetWindowTextLength,hLabel
			push eax
			invoke GetWindowTextLength,hCode
			pop edx
			.if eax && edx
				inc eax
				inc edx
				mov sn1.lsize,edx
				mov sn1.dsize,eax
				mov sn1.pLabel,malloc(sn1.lsize)
				mov sn1.pData ,malloc(sn1.dsize)
				invoke GetWindowText,hLabel,sn1.pLabel,sn1.lsize
				invoke GetWindowText,hCode ,sn1.pData ,sn1.dsize
				
				invoke memclone,addr sn1,Snippo
				mov pSnippo,eax
				mov SelSnippo,eax
				pcall AllSnippets.insert,eax
				
				invoke EnableWindow,hList,TRUE
				
				invoke SendMessage,hList,LB_ADDSTRING,0,sn1.pLabel
				mov SelIndex,eax
				invoke SendMessage,hList,LB_SETITEMDATA,eax,pSnippo
				invoke SendMessage,hList,LB_SETCURSEL,SelIndex,0				
				
				
				invoke ShowWindow,hbNewSnipp	,SW_SHOW
				invoke ShowWindow,hbDeleteSnipp	,SW_SHOW
				invoke ShowWindow,hbUpdateSnipp	,SW_SHOW
				invoke ShowWindow,hbOK		,SW_HIDE
				invoke ShowWindow,hbCancel	,SW_HIDE
				
			.endif
			;---------------------------------------------/
		.elseif wParam==1011
			;---------[ update snippet ]---------------------------------\
			invoke GetWindowTextLength,hLabel
			push eax
			invoke GetWindowTextLength,hCode
			pop edx
			.if eax && edx && SelSnippo
				inc eax
				inc edx
				mov sn1.lsize,edx
				mov sn1.dsize,eax
				mov sn1.pLabel,malloc(sn1.lsize)
				mov sn1.pData ,malloc(sn1.dsize)
				invoke GetWindowText,hLabel,sn1.pLabel,sn1.lsize
				invoke GetWindowText,hCode ,sn1.pData ,sn1.dsize
				invoke memclone,addr sn1,Snippo
				mov pSnippo,eax
				pcall AllSnippets.insert,eax
				
				invoke SendMessage,hList,LB_DELETESTRING,SelIndex,0
				pcall AllSnippets.delete,SelSnippo
				free SelSnippo
				
				invoke SendMessage,hList,LB_ADDSTRING,0,sn1.pLabel
				mov SelIndex,eax
				invoke SendMessage,hList,LB_SETITEMDATA,eax,pSnippo
				invoke SendMessage,hList,LB_SETCURSEL,SelIndex,0				
				
			.endif
			;------------------------------------------------------------/
		.elseif wParam==1008
			;------------[ delete snippet ]---------------------\
			.if SelSnippo
				mov eax,SelSnippo
				invoke MessageBox,hWin,T("Delete snippet?"),[eax].Snippo.pLabel,MB_YESNO or MB_DEFBUTTON2 or MB_ICONWARNING
				.if eax==IDYES
					pcall AllSnippets.delete,SelSnippo
					free SelSnippo
					mov SelSnippo,0
					invoke SendMessage,hList,LB_DELETESTRING,SelIndex,0
					jmp OnListBoxSelect
				.endif
			.endif
			;---------------------------------------------------/
		.elseif wParam==(1001 + (LBN_SELCHANGE shl 16))
			OnListBoxSelect:
			;---------[ on listbox select ]-------------------------------\
			invoke SendMessage,hList,LB_GETCURSEL,0,0
			.if eax==LB_ERR
				mov SelIndex,-1
				mov SelSnippo,0
				invoke ShowWindow,hbDeleteSnipp	,SW_HIDE
				invoke ShowWindow,hbUpdateSnipp	,SW_HIDE
				invoke SetWindowText,hLabel,0
				invoke SetWindowText,hCode,0
			.else
				mov SelIndex,eax
				invoke SendMessage,hList,LB_GETITEMDATA,eax,0
				mov SelSnippo,eax
				.if eax
					invoke SetWindowText,hLabel,[eax].Snippo.pLabel
					mov eax,SelSnippo
					invoke SetWindowText,hCode,[eax].Snippo.pData
					invoke ShowWindow,hbDeleteSnipp	,SW_SHOW
					invoke ShowWindow,hbUpdateSnipp	,SW_SHOW
				.endif
			.endif
			;-------------------------------------------------------------/
		.endif
	.elseif eax==WM_SIZE
		mov eax,lParam
		mov edx,eax
		shl eax,16
		shr eax,16
		shr edx,16
		sub eax,189+10
		sub edx,63+10
		invoke MoveWindow,hCode,189,63,eax,edx,TRUE
				
	.elseif eax==WM_CLOSE
		invoke EndDialog,hWin,0
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

DlgProc endp

end start
